/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */
/*
 * This file is part of libosso-abook
 *
 * Copyright (C) 2008-2009 Nokia Corporation. All rights reserved.
 *
 * Contact: Joergen Scheibengruber <jorgen.scheibengruber@nokia.com>
 */

#ifndef __OSSO_ABOOK_ERROR_H__
#define __OSSO_ABOOK_ERROR_H__

#include <gtk/gtk.h>
#include <libebook/e-book.h>

G_BEGIN_DECLS

#define osso_abook_check_disc_space(parent) \
        _osso_abook_check_disc_space ((parent), G_STRLOC, NULL)
#define osso_abook_check_disc_space_full(parent, path) \
        _osso_abook_check_disc_space ((parent), G_STRLOC, (path))

#define osso_abook_handle_gerror(parent, error) \
        _osso_abook_handle_gerror ((parent), G_STRLOC, (error))

#define osso_abook_handle_estatus(parent, error, book) \
        _osso_abook_handle_estatus ((parent), G_STRLOC, (error), (book))

#define OSSO_ABOOK_ERROR osso_abook_error_quark ()
typedef enum {
        OSSO_ABOOK_ERROR_OFFLINE,
        OSSO_ABOOK_ERROR_EBOOK,
        OSSO_ABOOK_ERROR_CANCELLED,
} OssoABookError;

GQuark
osso_abook_error_quark (void);

GError *
osso_abook_error_new_from_estatus (EBookStatus status);

gboolean
_osso_abook_check_disc_space (GtkWindow  *parent,
                              const char *strloc,
                              const char *path);

void
_osso_abook_handle_gerror    (GtkWindow  *parent,
                              const char *strloc,
                              GError     *error);

void
_osso_abook_handle_estatus   (GtkWindow  *parent,
                              const char *strloc,
                              EBookStatus status,
                              EBook      *book);

G_END_DECLS

#endif /* __ERROR_H__ */
