/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */
/*
 * This file is part of libosso-abook
 *
 * Copyright (C) 2008-2009 Nokia Corporation. All rights reserved.
 *
 * Contact: Joergen Scheibengruber <jorgen.scheibengruber@nokia.com>
 */

#ifndef __OSSO_ABOOK_MENU_EXTENSION_H__
#define __OSSO_ABOOK_MENU_EXTENSION_H__

#include "osso-abook-types.h"

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define OSSO_ABOOK_TYPE_MENU_EXTENSION \
                (osso_abook_menu_extension_get_type ())
#define OSSO_ABOOK_MENU_EXTENSION(obj) \
                (G_TYPE_CHECK_INSTANCE_CAST ((obj), \
                 OSSO_ABOOK_TYPE_MENU_EXTENSION, \
                 OssoABookMenuExtension))
#define OSSO_ABOOK_MENU_EXTENSION_CLASS(klass) \
                (G_TYPE_CHECK_CLASS_CAST((klass), \
                 OSSO_ABOOK_TYPE_MENU_EXTENSION, \
                 OssoABookMenuExtensionClass))
#define OSSO_ABOOK_IS_MENU_EXTENSION(obj) \
                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), \
                 OSSO_ABOOK_TYPE_MENU_EXTENSION))
#define OSSO_ABOOK_IS_MENU_EXTENSION_CLASS(klass) \
                (G_TYPE_CHECK_CLASS_TYPE ((klass), \
                 OSSO_ABOOK_TYPE_MENU_EXTENSION))
#define OSSO_ABOOK_MENU_EXTENSION_GET_CLASS(obj) \
                (G_TYPE_INSTANCE_GET_CLASS ((obj), \
                 OSSO_ABOOK_TYPE_MENU_EXTENSION, \
                 OssoABookMenuExtensionClass))

#define OSSO_ABOOK_DEFINE_MENU_PLUGIN(TN, t_n, TP, LC, UC)              \
                G_DEFINE_DYNAMIC_TYPE (TN, t_n, TP)                     \
                OSSO_ABOOK_DEFINE_MENU_PLUGIN_SYMBOLS (t_n, LC, UC)

#define OSSO_ABOOK_DEFINE_MENU_PLUGIN_SYMBOLS(t_n, LC, UC)              \
                                                                        \
G_MODULE_EXPORT void                                                    \
osso_abook_menu_plugin_load (GTypeModule *module);                      \
                                                                        \
void                                                                    \
osso_abook_menu_plugin_load (GTypeModule *module)                       \
{                                                                       \
        t_n##_register_type (module);                                   \
        {LC}                                                            \
}                                                                       \
                                                                        \
G_MODULE_EXPORT void                                                    \
osso_abook_menu_plugin_unload (GTypeModule *module);                    \
                                                                        \
void                                                                    \
osso_abook_menu_plugin_unload (GTypeModule *module)                     \
{                                                                       \
        {UC}                                                            \
}

struct _OssoABookMenuEntry {
        const char      *label;
        unsigned         accel_key;
        GdkModifierType  accel_mods;
        GCallback        callback;
        const char      *name;
};

struct _OssoABookMenuExtension
{
        GObject  parent_instance;
};

struct _OssoABookMenuExtensionClass
{
        GObjectClass  parent_class;
        const char   *name;

        /* extension interface */
        int                        (* get_n_menu_entries) (OssoABookMenuExtension *menu_extension);
        const OssoABookMenuEntry * (* get_menu_entries)   (OssoABookMenuExtension *menu_extension);
};

GType
osso_abook_menu_extension_get_type           (void) G_GNUC_CONST;

int
osso_abook_menu_extension_get_n_menu_entries (OssoABookMenuExtension *menu_extension);

const OssoABookMenuEntry *
osso_abook_menu_extension_get_menu_entries   (OssoABookMenuExtension *menu_extension);

G_END_DECLS

#endif /* __OSSO_ABOOK_MENU_EXTENSION_H_ */
